% this script plots the recording depth in deafened animals. 
% As no acoustic stimulation was possible here, there is no output saved. 
% This script is simply producing a figure. 

%% prepare workspace
clear all;  clc; close all;

%% chose files to analyze and load data (CF vs depth)
dirName = 'E:\projects\paper_uLED\revision\data\data_IC_MUA_acoustic\deafened\';
files_to_analyze = dir([dirName '\*mat']);

all_depths = []; 

for ii = 1:size(files_to_analyze, 1)   
    cur_file = files_to_analyze(ii).name; load([dirName cur_file])
   
    if ischar(Header.unit_depth) % due to a change in the recording software, in some animals, the depth has been saved as a string, in others as a number. this line makes sure, that for all animals, the depth is reported as a number.
       Header.unit_depth = str2num(Header.unit_depth);
    end
    
    all_depths  = vertcat(all_depths,   Header.unit_depth./1000);    
    clear cur_file 
end



f1 = figure('color', [1 1 1], 'units','normalized','position',[.3 .1 .25 .5]); hold on;
for ii = 1:length(all_depths)       
    cur_depth = all_depths(ii);  
    plot([1+(ii-1)*0.1 1+(ii-1)*0.1], [cur_depth+(32-1)*0.05 cur_depth].*-1, 'k-', 'LineWidth', 2)
end

ylim([1.6 3.7]); ylabel('depth [mm]');

xlim([0.5 1.5+length(all_depths)*0.1]); set(gca,'Ydir','reverse');
box on;
