% produces PSTHs and calculates the time window of significant responses. 
% It was used to determine the response window of all CatCh-transduced animals (hearing and deaf) 
% in response to the strongest illumination using all LEDs at once. 
% The same was done for the wildtype animals which showed responses. 


%% clean up and load data
clear all;  clc;

%% all CatCh-transduced animals
% files2analyze = {   'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad633_0004_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad791_0006_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad791_0009_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad791_0015_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad757_0004_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad757_0007_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad730_0006_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad730_0009_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad732_0004_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad732_0007_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad732_0010_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad731_0004_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad731_0007_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad731_0010_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad815_0003_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad815_0007_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad815_0009_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad815_0012_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\1142_0004_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\1142_0008_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\1142_0011_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad1200_0003_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad1200_0006_Resort'; % hearing
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\CatCh\gad1200_0008_Resort'; % hearing 
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\deafened\CatCh\GAD1093_0008_Resort'; % deaf
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\deafened\CatCh\GAD1093_0016_Resort'; % deaf
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\deafened\CatCh\GAD841_0003_Resort';  % deaf
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\deafened\CatCh\GAD841_0012_Resort';  % deaf
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\deafened\CatCh\gad1113_0003_Resort'; % deaf
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\deafened\CatCh\gad1113_0006_Resort'; % deaf
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\deafened\CatCh\gad1113_0009_Resort'; % deaf
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\deafened\CatCh\gad1113_0012_Resort'; % deaf
%                     'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\deafened\CatCh\gad1113_0015_Resort'};% deaf


% responsive wildypes
files2analyze = {   'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\WT\gad927_0002_Resort';  
                    'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\WT\gad927_0003_Resort';
                    'I:\projects\paper_uLED\revision\data\data_IC_MUA_opto\02_uLED_all\hearing\WT\gad927_0003_Resort'};


%% define parameters
t_start = -20/1000;  % time before stimulus onset in s
t_stop  =  50/1000; % time after stimulus onset in s
PSTH_binsize = 0.25/1000; % in s

sig_response_threshold = 3; % in std above baseline


%% run analysis
%% concatenate spike list (in time window of interest) across animals
Spik_list_all = [];
for xx = 1:size(files2analyze, 1)
    
    curFilename = files2analyze{xx};
    load(curFilename)
    spike_idx = (Spik_list(:, 6) > t_start) & (Spik_list(:, 6) < t_stop ) & (Spik_list(:, 1) == max(Spik_list(:, 1)));

    spikes_of_interest = Spik_list(spike_idx, 1:6);

    Spik_list_all = vertcat(Spik_list_all, spikes_of_interest);
    
    clear Spik_list spike_idx spikes_of_interest
end


%% create and normalize PSTH of all these spikes
PSTH_bins = [t_start:PSTH_binsize:t_stop];
PSTH = histc(Spik_list_all(:, 6),PSTH_bins);
PSTH_norm = PSTH./max(PSTH); % normalize PSTH to maximum response
mean_baseline = mean(PSTH_norm(PSTH_bins < 0)); % determine the mean of baseline activity
std_baseline  = std(PSTH_norm(PSTH_bins < 0));  % determine the standard deviation of baseline activity



%% get the time window of significant responses
resp_threshold = (mean_baseline+sig_response_threshold*std_baseline);
idx_bigger_baseline = find(PSTH_norm > resp_threshold);
for xx = 1:length(idx_bigger_baseline) 
   cur_idx = idx_bigger_baseline(xx); % find bin above threshold
   % if the two subsequent bins are also above thershold, this is considered the response onset
   if (PSTH_norm(cur_idx+1) >  resp_threshold) & (PSTH_norm(cur_idx+2) >  resp_threshold);
       resp_start = cur_idx;
       break
   end
end

idx_bigger_baseline_after_onset = idx_bigger_baseline(idx_bigger_baseline > resp_start); % after the onset of the response...
for xx = 1:length(idx_bigger_baseline_after_onset)
   cur_idx = idx_bigger_baseline_after_onset(xx); % ...find bin below threshold  
   % if the two subsequent bins are also below threshold, this is considered  the response offset
   if (PSTH_norm(cur_idx+1) <  resp_threshold) & (PSTH_norm(cur_idx+2) <  resp_threshold);
       resp_stop = cur_idx;
       break
   end 
end

resp_idx = zeros(length(PSTH_bins), 1); resp_idx(resp_start:resp_stop) = 1;
timewindow_response = PSTH_bins(resp_idx == 1);
t_onset = timewindow_response(1); t_offset = timewindow_response(end);


%% ...finally create your figure
f0 = figure('color', [1 1 1], 'units','normalized','position',[.2 .1 0.35 .7]); hold on;

% subplot(5, 1, 1); hold on;
bar(PSTH_bins, PSTH_norm, 'FaceColor', [0.5 0.5 0.5], 'EdgeColor', [0.7 0.7 0.7]);
bar(PSTH_bins(resp_idx == 1), PSTH_norm(resp_idx == 1), 'FaceColor', 'k', 'EdgeColor', 'k');
plot([0 0], [0 1], 'b-'); plot([0.001 0.001], [0 1], 'b-');
plot([-0.25 0.5], [mean_baseline mean_baseline], 'k-'); plot([-0.25 0.5], resp_threshold*[1, 1], 'k--');
set(gca, 'XTick', -0.1:0.02:0.3); xlim([t_start/1000 t_stop/1000]);
set(gca, 'YTick', [0:0.5:1]); ylabel('firing rate (norm)');
xlim([-0.005 0.025]); ylim([0 1]);
text(0.02, 0.4, ['t_o_n = ' num2str(t_onset*1000) ' ms'])
text(0.02, 0.35, ['t_o_f_f = ' num2str(t_offset*1000) ' ms'])
box on; ylim([0 1]); set(gca, 'YTick', [0:0.1:0.5]);