% These scripts perform the d analysis for stimulation using an oCI and activating individual LEDs. 
% different datasets can be chosen by (un)commenting the variable files2analyze) in the beginning of the script. 
% Correspondingly, the line save with the corresponding filename to be saved needs to be uncommented at the end of each script, 
% in order to save the analysis of different datasets with different filenames. 
% The saved files will later be called in different scripts. 

clear all; close all; clc;

%% indiv. uLED stimulation hearing animals
% files2analyze  = {  'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad731_0006_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad731_0009_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad731_0012_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad815_0005_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad815_0011_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad791_0008_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad730_0011_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad791_0012_Resort';
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad791_0013_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad757_0006_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad757_0012_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad730_0008_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\1142_0006_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\1142_0010_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\1142_0013_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad1200_0010_Resort'}; 

%% indiv. uLED stimulation deaf animals
% files2analyze  = {  'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\GAD1093_0010_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\GAD1093_0015_Resort';  
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\GAD841_0005_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\GAD841_0014_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0005_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0008_Resort';
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0011_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0014_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0017_Resort'}; 


%% indiv. uLED stimulation - combined
% files2analyze  = {  'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad731_0006_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad731_0009_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad731_0012_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad815_0005_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad815_0011_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad791_0008_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad730_0011_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad791_0012_Resort';
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad791_0013_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad757_0006_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad757_0012_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad730_0008_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\1142_0006_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\1142_0010_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\1142_0013_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\hearing\gad1200_0010_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\GAD1093_0010_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\GAD1093_0015_Resort';  
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\GAD841_0005_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\GAD841_0014_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0005_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0008_Resort';
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0011_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0014_Resort'; 
%                     'E:\projects\paper_uLED\revision\data\data_IC_MUA_opto\03_uLED_individual\deaf\gad1113_0017_Resort'}; 


%% start and stop of time window to analyze spikerate and electrodes to analyze
n_leds = 16;
led_intensities = [0.02, 0.14, 0.24, 0.33, 0.42, 0.50, 0.57, 0.63, 0.68, 0.72, 0.75]; % values taken from calibration file
spikewindow_start = 0.003; spikewindow_stop = 0.020; % in seconds
n_electrodes = 32; % 32 channel electrode array
all_electrodes = [1:n_electrodes]-1; 

DprimeThreshold = 1;

%% read out matrix of firing rate per stimulus per electrode for each animal and compute the cumulative d' values of this data
for aa = 1:size(files2analyze, 1)

    curFileName = files2analyze{aa, 1};
    [animal_ID, unit_depth, track_number, exp_type]    =   getInfo(curFileName);
    all_IDs{aa} = animal_ID; all_depths(aa) = unit_depth;
    load(curFileName);
   
    
    tEvalWin = [spikewindow_start, spikewindow_stop];
    Lvl = unique(cell2mat(Header.stimlist(:, 3)));  [sortLvl, iSortLvl] = sort(Lvl);
    
    %initiate variables
    all_DprimeMats = zeros(length(all_electrodes), length(Lvl)-1);
    
    % for each uLED on the array
    for i_LED = 1:n_leds
        
             % go over all electrodes
        for yy = 1:length(all_electrodes)
            curElectrode = all_electrodes(yy);
            icurElectrode = find(Spik_list(:,4) == curElectrode); cur_Spik_list = Spik_list(icurElectrode,:);
            un_stim = unique(Spik_list(:,1));
            StimResp = cell(Header.ncond/n_leds,1);
            RespRate = zeros(Header.ncond/n_leds,3);
            RespRate(:) = NaN;
            
            %...and all intensities
            for curStim =  i_LED*length(Lvl)-(length(Lvl)-1):i_LED*length(Lvl)
                nRepCurStim = unique(Header.n_rep);
                RespDummyRate = zeros(1,nRepCurStim);
                for curRep = 1:nRepCurStim
                    nSpikesInResp = sum(cur_Spik_list(:,1) == un_stim(curStim,1) & cur_Spik_list(:,2) == curRep & cur_Spik_list(:,6) > tEvalWin(1) & cur_Spik_list(:,6) <= tEvalWin(2));
                    RespDummyRate(curRep) = nSpikesInResp./diff(tEvalWin);
                end
                StimResp{curStim-((i_LED-1)*length(Lvl))} = RespDummyRate;
                RespRate(curStim-((i_LED-1)*length(Lvl)),1:3) = [mean(RespDummyRate),std(RespDummyRate),nRepCurStim];
            end
            
            % perform ROC analysis
            nComp = size(Lvl,1)-1;
            colorMat = jet(nComp);
            DprimeMat = zeros(nComp,1);
            ROC      = cell(nComp,1);
            AUCMat   = zeros(nComp,2);
            
            for curStimComp = 1:nComp
                N = StimResp{iSortLvl(curStimComp)};
                P = StimResp{iSortLvl(curStimComp+1)};
                
                [ROCmat, AUC, Dprime, SE] = ROCAna_02(N, P, 0);
                DprimeMat(curStimComp,1) = Dprime;
                AUCMat(curStimComp,1:2) = [AUC, SE];
                ROC{curStimComp,1} = ROCmat;
            end
            
            % get threshold
            CumulativeDprimeMat = NaN(size(DprimeMat));
            iAboveThreshold = find(DprimeMat >= DprimeThreshold ,1, 'first');
            
                all_DprimeMats(yy, :)           = DprimeMat;     
        end
    
        all_Dprimes_cumsum(:, :, i_LED) = cumsum([zeros(n_electrodes, 1) all_DprimeMats], 2);

    end
    
    all_Dprimes_cumsum_across_animals(:, :, (aa*n_leds)-n_leds+1:(aa*n_leds)) =   all_Dprimes_cumsum;
end

%% the variable "all_Dprimes_cumsum_across_animals" contains all d prime values for all animals. Now you can use this to do further calculations
% analyze spatial spread for individual animals
for xx = 1: size(all_Dprimes_cumsum_across_animals, 3)
    clear s
    cur_data =all_Dprimes_cumsum_across_animals(:, :, xx);
    
    if rem(xx, n_leds) == 1; figure('color', [1 1 1], 'units','normalized','position',[.1, .1, .6000, .800]); end
    if rem(xx, n_leds) > 0; subplot(4, 4, rem(xx, n_leds)); elseif rem(xx, n_leds) == 0; subplot(4, 4, n_leds); end
        
        
    title(['cumulative d' sprintf( '\''' ) '-values']);
    clear contour_matrix contour_lines
    [contour_matrix, ~] = contourf(led_intensities ,1:n_electrodes,cur_data,[DprimeThreshold DprimeThreshold]); 
    if any(contour_matrix)
    contour_lines = getcontourlines(contour_matrix); % define contour lines at this stage (for threshold at dprime = x)
    else
    contour_lines = [];
    end
    
    contourf(led_intensities ,1:n_electrodes,cur_data, [floor(min(min(cur_data))):1:ceil(max(max(cur_data)))]); hold on;
    c = colorbar; caxis([-1 3]); set(c,'XTick',[-1:1:6]); colormap gray;
    ylabel(c, ['d' sprintf( '\''' ) '-value']); cur_cmap = get(gcf,'Colormap'); set(gcf,'Colormap',flipud(cur_cmap));
    
    % get thresholds based on open contour lines
    i_threshold = 0; thresholds = {};
    
    for zz = 1:size(contour_lines, 2)
        if (contour_lines(zz).x(1) == contour_lines(zz).x(end) && contour_lines(zz).y(1) == contour_lines(zz).y(end)) | sum(contour_lines(zz).x == 1) > 0 % contour is closed
        else
            
            plot(contour_lines(zz).x, contour_lines(zz).y, 'b', 'linewidth', 1) ;           % contour is open
            i_threshold = i_threshold + 1;
            thresholds(i_threshold).x = contour_lines(zz).x; thresholds(i_threshold).y = contour_lines(zz).y;
            
        end
    end
    
    
    set(gca,'YTick', [2:2:n_electrodes], 'YtickLabel', [2:2:n_electrodes], 'Xtick', sortLvl(2:end), 'Xticklabel',  sortLvl(2:end));
    xlabel('LaserIntensity [mW]'); ylabel('Electrode #');set(gca,'Ydir','reverse')
    
    channels = [1:n_electrodes]';
    thresholds_by_channel = zeros(1, n_electrodes)';
    
    for yy = 1:size(thresholds, 2)
        cur_thresholds = thresholds(yy);
        for ii = 1:size(channels)
            cur_channel = channels(ii);
            if nnz(ismember(cur_thresholds.y, cur_channel)) > 0
                idx_threshold = find(ismember(cur_thresholds.y, cur_channel));
                cur_threshold = cur_thresholds.x(idx_threshold);
                
                if length(cur_threshold) > 1
                    [minval, minloc] = min(cur_threshold);
                    cur_threshold = cur_threshold(minloc);
                    thresholds_by_channel(cur_channel) = cur_threshold;
                else
                    thresholds_by_channel(cur_channel) = cur_threshold;
                end
            end
        end
    end
    
    
    threshold_cutoff = Lvl(end-2);
    thresholds_by_channel(thresholds_by_channel > threshold_cutoff) = NaN; % blank channels below threshold
    thresholds_by_channel(thresholds_by_channel == 0) = NaN; % blank channels below threshold
    abs_thresholds(xx, :) = thresholds_by_channel;
    plot(thresholds_by_channel(~isnan(thresholds_by_channel)), channels(~isnan(thresholds_by_channel)), 'b*')
    
 
end

analysis_part_02_metadata.IDs = all_IDs;
analysis_part_02_metadata.thresholds = abs_thresholds;
analysis_part_02_metadata.dprime_cumsum = all_Dprimes_cumsum_across_animals;

%% uncomment the following line in order to actually save the output
%  save (['STCs_uLED_individual_3to20ms_hearing.mat'], 'analysis_part_02_metadata')
%  save (['STCs_uLED_individual_3to20ms_deaf.mat'], 'analysis_part_02_metadata')
%  save (['STCs_uLED_individual_3to20ms_all.mat'], 'analysis_part_02_metadata')
 
 